package arcade.assignments;

import arcade.database.DBConnection;

import java.sql.*;

public class AssignmentCalendarEvent extends arcade.database.DBObject {
	private int m_nID;
	private int m_nIDAssignment = -1;
	private int m_nIDCalendarEvent = -1;
	private int m_nIDCourse = -1;
	
	private static final String C_table_name = "TASK_CALENDAR_EVENTS";
	
	public AssignmentCalendarEvent() {
		super();
	}
	
	protected java.sql.PreparedStatement getDeleteStatement(arcade.database.DBConnection dbConnection) {
		String sQuery = "delete from " + getTableName() + " where ID = " + m_nID;

		PreparedStatement ps = null;
		try {
			Connection connection = dbConnection.getConnection();
			ps = connection.prepareStatement(sQuery);
		} catch (Exception e) {
			ps = null;
		}

		return ps;
}

	protected java.sql.PreparedStatement getUpdateStatement(arcade.database.DBConnection dbConnection) {
		String q = "SELECT A.ID FROM TASK_CALENDAR_EVENTS A, CALENDAR_EVENTS B "
		+ " WHERE A.ASSIGNMENTS_ID=" + m_nIDAssignment
		+ " AND A.CALENDAR_EVENTS_ID=B.ID AND B.COURSE_INST_ID=" + m_nIDCourse;
		int nID = -1;
		PreparedStatement ps = null;
		try {
			ResultSet rs = DBConnection.query(q);
			rs.next();
			nID = rs.getInt("ID");
			String sQuery = "update " + getTableName() + " set CALENDAR_EVENTS_ID = ? where ID = " + nID;
			Connection connection = dbConnection.getConnection();
			ps = connection.prepareStatement(sQuery);				
			ps.setInt(1, m_nIDCalendarEvent);
			DBConnection.closeResultSet(rs);
			rs.close();
		} catch (Exception e) {
			ps = null;
		}	
		return ps;
	}

	protected PreparedStatement getInsertStatement(arcade.database.DBConnection dbConnection) {
		String sQuery = "insert into " + getTableName() + 
				"(ASSIGNMENTS_ID, CALENDAR_EVENTS_ID) values(?, ?)";
		System.out.println("dd: insert za task_calendar_events: " + sQuery);
		PreparedStatement ps = null;
		try {
			Connection connection = dbConnection.getConnection();
			ps = connection.prepareStatement(sQuery);
			ps.setInt(1, m_nIDAssignment);
			ps.setInt(2, m_nIDCalendarEvent);
		} catch (Exception e) {
			ps = null;
		}
		return ps;
	}

	protected CallableStatement getInsertFetchStatement(DBConnection dbConnection) {
		String sCall =
				"begin " +
				"insert into " + getTableName() + "(ASSIGNMENTS_ID, CALENDAR_EVENTS_ID) values(?, ?) returning ID into ?; " +
				"end;";
		CallableStatement cs = null;
		try {
			cs = dbConnection.getConnection().prepareCall(sCall);
			cs.setInt(1, m_nIDAssignment);
			cs.setInt(2, m_nIDCalendarEvent);

			cs.registerOutParameter(3, java.sql.Types.NUMERIC);
		} catch (Exception e) {
			cs = null;
		}
		return cs;
	}

	protected void fetchAfterInsert(CallableStatement cs) throws Exception {
		m_nID = cs.getInt(3);
	}

	public void initialize(ResultSet resultSet) throws SQLException{
		m_bInDatabase = true;
		m_nID = resultSet.getInt("ID");
		m_nIDAssignment = resultSet.getInt("ASSIGNMENTS_ID");
		m_nIDCalendarEvent = resultSet.getInt("CALENDAR_EVENTS_ID");
		String q = "SELECT COURSE_INST_ID FROM calendar_events, task_calendar_events "
				+ "WHERE calendar_events.ID=task_calendar_events.CALENDAR_EVENTS_ID AND "
				+ "task_calendar_events.CALENDAR_EVENTS_ID=" + m_nIDCalendarEvent;
		try {
			ResultSet rs = DBConnection.query(q);
			rs.next();
			m_nIDCourse = rs.getInt("COURSE_INST_ID");
			DBConnection.closeResultSet(rs);
			rs.close();
		} catch (Exception e) {
			m_nIDCourse = -1;
		}
	}

	public void initialize(int nIDAssignment, int nIDCalendarEvent, int nIDCourse){
		m_bInDatabase = false;
		setIDAssignment(nIDAssignment);
		setIDCalendarEvent(nIDCalendarEvent);
		setIDCourse(nIDCourse);
	}

	public void setIDAssignment(int nIDAssignment){
		m_nIDAssignment = nIDAssignment;
	}

	public void setIDCalendarEvent(int nIDCalendarEvent){
		m_nIDCalendarEvent = nIDCalendarEvent;
	}

	public void setIDCourse(int nIDCourse){
		m_nIDCourse = nIDCourse;
	}

	public String getTableName() {
		return C_table_name;
	}

	public boolean exists() throws Exception {
		boolean bResult;
		String q = "SELECT A.* FROM TASK_CALENDAR_EVENTS A, CALENDAR_EVENTS B "
				+ " WHERE A.ASSIGNMENTS_ID=" + m_nIDAssignment
				+ " AND A.CALENDAR_EVENTS_ID=B.ID AND B.COURSE_INST_ID=" + m_nIDCourse;
		ResultSet rs = DBConnection.query(q);
		if (rs.next())
			bResult = true;
		else
			bResult = false;
		DBConnection.closeResultSet(rs);
		rs.close();
		return bResult;
	}
}