package arcade.assignments;

import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Vector;

import arcade.ccim.courseinstancemanagement.CourseInstance;
import arcade.database.DBConnection;
import arcade.usermanagement.User;
import arcade.util.Dialog;
import arcade.util.SMTP;
import arcade.util.WebBean;
import arcade.util.html.Button;
import arcade.util.html.ButtonBar;
import arcade.util.html.Header;
import arcade.util.html.InputForm;
import arcade.util.html.LetterSelector;
import arcade.util.html.OperationResult;
import arcade.util.html.Select;
import arcade.util.html.StaticText;
import arcade.util.html.Table;

import arcade.util.i18n.MessagesBundle;
import arcade.ArcadeConstants;

public class GiveAssignmentStudentSideDlg extends Dialog {
	int m_nAction = 0;
	transient private int m_nIDCourseInstance = -1;
	transient private int m_nIDCalendarEvent = -1;
	transient private int m_nIDAssignment = -1;

	public GiveAssignmentStudentSideDlg(Dialog dlg) {
		super("GiveAssignmentStudentSideDlg", dlg);
	}

	public GiveAssignmentStudentSideDlg(String sAction) {
		super("GiveAssignmentStudentSideDlg", sAction, "");
		System.out.println("GiveAssignmentStudentSideDlg::<init>: with paramater " + sAction);
	}

	protected void onMapVar() {
		mapVar("m_nIDCourseInstance", "CourseIndex", c_VAR_IN);
		mapVar("m_nIDCalendarEvent", "CalendarEvent", c_VAR_IN);
		mapVar("m_nIDAssignment", "Assignment", c_VAR_IN);
	}

	protected void paint(WebBean wb) {
		try {
			if (!isValid("m_nIDCourseInstance")) m_nIDCourseInstance = -1;
			if (!isValid("m_nIDCalendarEvent")) m_nIDCalendarEvent = -1;
			if (!isValid("m_nIDAssignment")) m_nIDAssignment = -1;
			
			
			InputForm form = new InputForm(this);
			addHiddenField("form", "1");
			
			form.addHiddenField("Assignment", "" + m_nIDAssignment);
			
			String sLetter = wb.getRequestParameter("letter");
			char cLetter = LetterSelector.C_NO_LETTER_SELECTED;
			if (sLetter.length() > 0) cLetter = sLetter.toCharArray()[0];
			addHiddenField("letter", "");
			
			boolean bWrite = false, bError = false;
			String sError = new String();
			Event ev = new Event();
			
			if (m_nAction == 1) {
				bWrite = true;
				String queryString = "SELECT CALENDAR_EVENTS.START_DATE, CALENDAR_EVENTS.END_DATE, "
					+ "ASSIGNMENTS.NAME, ASSIGNMENTS.DESCRIPTION "
					+ "FROM CALENDAR_EVENTS, TASK_CALENDAR_EVENTS, ASSIGNMENTS WHERE "
					+ "CALENDAR_EVENTS.TYPE='Assignment' AND CALENDAR_EVENTS.COURSE_INST_ID = "
					+ m_nIDCourseInstance + " AND CALENDAR_EVENTS.ID = TASK_CALENDAR_EVENTS.CALENDAR_EVENTS_ID "
					+ "AND TASK_CALENDAR_EVENTS.ASSIGNMENTS_ID = ASSIGNMENTS.ID "
					+ "AND ASSIGNMENTS.ID = " + m_nIDAssignment;
				ResultSet rSet = DBConnection.query(queryString);
				rSet.next();
				java.sql.Date dtStartDate = rSet.getDate("START_DATE");
				java.sql.Date dtEndDate = rSet.getDate("END_DATE");
				
				
				String sStatus;
				java.util.Date today = new java.util.Date();
				if (today.after(dtStartDate)) {
					bError = true;
					sError += MessagesBundle.getString("key_task_cannot_be_subscribed", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()) + "!<BR>";
				}
				
				if (!bError) {
					sStatus = new String("Active");
					ev.initialize(m_nIDAssignment, (int)wb.getLoggedUserID(), rSet.getString("NAME"), "Assignment", "", dtStartDate, dtEndDate, sStatus, m_nIDCourseInstance);
					
					if (ev.possible(m_nIDCourseInstance)) {
						ev.insertFetch(DBConnection.getDBConnection());
						User user =  new User(wb.getLoggedUserID());
						SMTP smtp = new SMTP("10.200.200.13", 25);
						smtp.setVerbose(true);
						CourseInstance ci = new CourseInstance();
						ci.initialize(m_nIDCourseInstance);
						String[] msg = {MessagesBundle.getString("key_assignment_has_been_scheduled_to_you", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()) +".",
							MessagesBundle.getString("key_course_name", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()) +": " + ci.getName(),
							MessagesBundle.getString("key_starting_assignment_date", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()) +":" + ev.getStartDate().toString(),
							MessagesBundle.getString("key_end_assignment_date", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()) +":" + ev.getEndDate().toString()
						};
						
					} else {
						sError += MessagesBundle.getString("key_user_has_an_assingment2", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()) + "<BR>";
						bError = true;
					}
				}
				DBConnection.closeResultSet(rSet);
                		rSet.close();
				if (!bError) {
					OperationResult oResult = new OperationResult ();
					oResult.setTitle(MessagesBundle.getString("key_assignment_assinged", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()));
					oResult.setButtonTitle(MessagesBundle.getString("key_go_back_to_assignments", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()));
					addHandler(oResult, "OnBack", c_EVENT_ON_CLICK);
					oResult.setMessage(MessagesBundle.getString("key_assignment_successfully_assigned", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()));
					addVisualObject(oResult);
					addVisualObject(form);
				}
			}
			
			if ((!bWrite) || bError) {
				
				addVisualObject(new Header(
				MessagesBundle.getString("key_assignements", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
			 	"center"));
				
				if (bError) {
					StaticText stError = new StaticText();
					stError.setText("<p align=\"center\"><font color=\"#FF0000\">" +
						sError + "</font></p>");
					addVisualObject(stError);
				}
			
				Select select = new Select("CourseIndex", 1);
				select.addOption("", "-1", (m_nIDCourseInstance == -1) ? true : false);
				
				ArrayList listc = ManageAssignmentsUI.getCourseInstancesForStudent((int)wb.getLoggedUserID(), true);
				CourseInstance ci;
				for (int nIndex = 0, nCount = listc.size(); nIndex < nCount; nIndex++) {
					ci = (CourseInstance)listc.get(nIndex);
					select.addOption(ci.getName(), String.valueOf(ci.getID()),
						(m_nIDCourseInstance == ci.getID()) ? true : false);
				}
				addHandler(select, "OnCourseInstanceSelect", c_EVENT_ON_CHANGE);
				form.addInput(
					MessagesBundle.getString("key_course_instance", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
			 		select);
			 	
			 	Select select2 = new Select("CalendarEvent", 1);
			 	select2.addOption("", "-1", (m_nIDCalendarEvent == -1) ? true : false);
			 	ArrayList listc2 = ManageAssignmentsUI.getCalendarEventsAssignments(m_nIDCourseInstance, true);
				CalendarEvent cev;
				for (int nIndex = 0, nCount = listc2.size(); nIndex < nCount; nIndex++) {
					cev = (CalendarEvent)listc2.get(nIndex);
					select2.addOption(cev.getName(), String.valueOf(cev.getID()),
						(m_nIDCalendarEvent == cev.getID()) ? true : false);
				}
				addHandler(select2, "OnCalendarEventSelect", c_EVENT_ON_CHANGE);
				form.addInput(
					MessagesBundle.getString("key_calendar_event", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
			 		select2);
			 	
			 	addVisualObject(form);
			 	
			 	addVisualObject(new StaticText ("<BR>"));
			 	
			 	LetterSelector letterSelector = new LetterSelector ("javascript: refresh(); //");
				letterSelector.addOnClick("document.forms[0].letter.value=cLetter;");
				letterSelector.setSelectedLetter(cLetter);
				addVisualObject(letterSelector);
			 	
			 	ArrayList banks = null;
			 	int nBanksCount = 0;
			 	if (m_nIDCourseInstance > 0) {
			 		banks = ManageAssignmentsUI.getBanks(m_nIDCourseInstance, true);
			 		nBanksCount = banks.size();
			 	}
			 	Bank bank;
			 	Vector bank_ids = new Vector();
			 	for (int nIndex = 0; nIndex < nBanksCount; nIndex++) {
			 		bank = (Bank)banks.get(nIndex);
			 		bank_ids.add(new Integer (bank.getID()));
			 	}
			 	
			 	Table table = new Table("Event");
				table.addBorderTable(false);
				table.setWidth("100%");

       				table.setColumnLabels(new String[]{
							MessagesBundle.getString("key_description", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
							MessagesBundle.getString("key_assigned_to", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale())
							});
				
				table.setColumnWidths(new int[]{0, 120});

				ArrayList events = null;
				String sWhere = "";
				if (cLetter != LetterSelector.C_NO_LETTER_SELECTED)
					sWhere = " AND (ASSIGNMENTS.NAME like('" + Character.toUpperCase(cLetter) + "%') or " +
					"ASSIGNMENTS.NAME like('" + Character.toLowerCase(cLetter) + "%'))";
				
				try {
				
					String q = "SELECT CALENDAR_EVENTS.START_DATE, CALENDAR_EVENTS.END_DATE, "
						+ "ASSIGNMENTS.ID, ASSIGNMENTS.NAME, ASSIGNMENTS.DESCRIPTION "
						+ "FROM CALENDAR_EVENTS, TASK_CALENDAR_EVENTS, ASSIGNMENTS WHERE "
						+ "CALENDAR_EVENTS.ID = " + m_nIDCalendarEvent + " AND CALENDAR_EVENTS.COURSE_INST_ID = " 
						+ m_nIDCourseInstance + " AND CALENDAR_EVENTS.ID = TASK_CALENDAR_EVENTS.CALENDAR_EVENTS_ID "
						+ "AND TASK_CALENDAR_EVENTS.ASSIGNMENTS_ID = ASSIGNMENTS.ID AND ASSIGNMENTS.ASSIGNED_BY_INSTRUCTOR=0"
						+ sWhere;
					
					System.out.println("dd: " + q);
					ResultSet rs = DBConnection.query(q);
          				while (rs.next()) {

						table.addRow(rs.getInt("ID"), new String[]
										{
							"<br><b>"+MessagesBundle.getString("key_task_name", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale())+": </b>&#34;"+rs.getString("NAME")+"&#34;</b><br><br>"+
							rs.getString("DESCRIPTION")+ "<br>" +
							"<br><b>" + MessagesBundle.getString("key_end_date_for_assigning", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale())+": </b>"+"<i>"+rs.getDate("START_DATE")+"</i><br> "+
							"<b>" + MessagesBundle.getString("key_end_date_for_result", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale())+": </b>"+"<i><font color='red'>"+rs.getDate("END_DATE")+"</font></i>",											
						ManageAssignmentsUI.getStudentsForAssignment(rs.getInt("ID"), 0)
						});

					}

					DBConnection.closeResultSet(rs);
						
				} catch (Exception e) {
					System.out.println("dd: " + e.getMessage());
					e.printStackTrace();
				}
								
				table.setOnSelect("document.forms[0].Assignment.value=this.value; TakeAss.disabled = false; ViewAss.disabled = false;");
				addVisualObject(table);
				addVisualObject(new StaticText ("<br>"));
				ButtonBar bar = new ButtonBar();
				bar.setAlignment("center");
				Button bnTakeAss = new Button(Button.C_TYPE_BUTTON,
									 MessagesBundle.getString("key_subscribe_for_this_task", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
									 null);
				bnTakeAss.setName("TakeAss");
				Button bnViewAss = new Button(Button.C_TYPE_BUTTON,
									 	MessagesBundle.getString("key_view_assignment", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
									  	null);
				bnViewAss.setName("ViewAss");
				addHandler(bnTakeAss, "OnTakeAss", c_EVENT_ON_CLICK);
				addHandler(bnViewAss, "OnViewAss", c_EVENT_ON_CLICK);
				if (m_nIDAssignment < 1 || m_nIDCourseInstance < 1) {bnTakeAss.Disable(); bnViewAss.Disable();}
				bar.addButton(bnTakeAss);				
				bar.addButton(bnViewAss);
				addVisualObject(bar);
			}		 		
		} catch (Exception e) {}
	}

	private Dialog OnCourseInstanceSelect(WebBean wb) {
		m_nIDCalendarEvent = -1;
		m_nIDAssignment = -1;		
		return this;
	}
	private Dialog OnCalendarEventSelect(WebBean wb) {
		m_nIDAssignment = -1;		
		return this;
	}

	private Dialog OnTakeAss(WebBean wb) {
		m_nAction = 1;
		return this;
	}
	
	private Dialog OnBack(WebBean wb) {
		m_nAction = 0;
		return this;
	}
	
	private Dialog OnViewAss(WebBean wb) {
		if (!isValid("m_nIDAssignment")) m_nIDAssignment = -1;
		if (m_nIDAssignment < 1) return this;
		m_nAction = 0;
		return new AssignmentDlg(this, AssignmentDlg.c_TYPE_VIEW);		
	}
}