package arcade.assignments;

import java.sql.ResultSet;
import java.util.ArrayList;

import arcade.ArcadeConstants;
import arcade.database.DBConnection;
import arcade.util.Dialog;
import arcade.util.WebBean;
import arcade.util.html.Button;
import arcade.util.html.ButtonBar;
import arcade.util.html.Header;
import arcade.util.html.InputForm;
import arcade.util.html.OperationResult;
import arcade.util.html.Select;
import arcade.util.html.StaticText;
import arcade.util.html.Table;
import arcade.util.i18n.MessagesBundle;

public class SetEventDlg extends Dialog {
	
	int m_nAction = 0;
	transient int m_nIDAssignment = -1;
	transient int m_nIDCalendarEvent = -1;
	transient int m_nIDBank = -1;
	transient private int m_nIDCourseInstance = -1;
	
	public SetEventDlg(Dialog dlg) {
		super("SetEventDlg", dlg);
	}
	protected void onMapVar() {
		mapVar("m_nIDCalendarEvent", "CalendarEvent", c_VAR_IN);
		mapVar("m_nIDAssignment", "Assignment", c_VAR_IN);
		mapVar("m_nIDBank", "BankIndex", c_VAR_INOUT);
		mapVar("m_nIDCourseInstance", "CourseIndex", c_VAR_INOUT);
	}
	protected void paint(WebBean wb) {
		try {
			if (!isValid("m_nIDAssignment")) m_nIDAssignment = -1;
			if (!isValid("m_nIDCalendarEvent")) m_nIDCalendarEvent = -1;
			if (!isValid("m_nIDBank")) m_nIDBank = -1;
			if (!isValid("m_nIDCourseInstance")) m_nIDCourseInstance = -1;
			
			InputForm form = new InputForm(this);
			
			boolean bWrite = false, bError = false;
			String sError = new String();
			AssignmentCalendarEvent acev = new AssignmentCalendarEvent();
			
			if (m_nAction == 1) {
				bWrite = true;
				acev.initialize(m_nIDAssignment, m_nIDCalendarEvent, m_nIDCourseInstance);
				if (acev.exists()) {
					acev.setInDatabase(true);
					acev.update(DBConnection.getDBConnection());
				} else 
					acev.insertFetch(DBConnection.getDBConnection());
				
				if (!bError) {
					OperationResult oResult = new OperationResult ();
					oResult.setTitle(MessagesBundle.getString("key_set_event", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()));
					oResult.setButtonTitle(MessagesBundle.getString("key_go_back_to_assignments", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()));
					addHandler(oResult, "OnBack", c_EVENT_ON_CLICK);
					oResult.setMessage(MessagesBundle.getString("key_event_successfully_set", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()));
					addVisualObject(oResult);
					addVisualObject(form);
				}
			}
			if ((!bWrite) || bError) {
				
				addVisualObject(new Header(
				MessagesBundle.getString("key_set_event", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
			 	"center"));
			 	
			 	if (bError) {
					StaticText stError = new StaticText();
					stError.setText("<p align=\"center\"><font color=\"#FF0000\">" +
						sError + "</font></p>");
					addVisualObject(stError);
				}
				
				Select select = new Select("Assignment", 1);
				select.addOption("", "-1", (m_nIDAssignment == -1) ? true : false);
				
				ArrayList listAssignments = ManageAssignmentsUI.getAssignments(m_nIDBank, true, "");
				Assignment a;
				for (int nIndex = 0, nCount = listAssignments.size(); nIndex < nCount; nIndex++) {
					a = (Assignment)listAssignments.get(nIndex);
					select.addOption(a.getName(), String.valueOf(a.getID()),
						(m_nIDAssignment == a.getID()) ? true : false);
				}
				addHandler(select, "OnAssignmentSelect", c_EVENT_ON_CHANGE);
				form.addInput(
					MessagesBundle.getString("key_assignment", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
			 		select);
			 	addVisualObject(form);
			 	
			 	Table table = new Table("CalendarEvent");
			 	table.addBorderTable(false);
				table.setWidth("100%");
				table.setColumnLabels(new String[]{
								  MessagesBundle.getString("key_type", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
								  MessagesBundle.getString("key_name", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
								  MessagesBundle.getString("key_description", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
								  MessagesBundle.getString("key_start_date", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
								  MessagesBundle.getString("key_end_date", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
								  MessagesBundle.getString("key_points", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
								  MessagesBundle.getString("key_mandatory", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale())
								  });
				table.setColumnWidths(new int[]{80, 80, 260, 100, 100, 40, 0});
				ArrayList calendarEvents = null;
				if (m_nIDCourseInstance > 0) calendarEvents = ManageAssignmentsUI.getCalendarEvents(m_nIDCourseInstance, true);
				boolean checked;
				for (int nEvent = 0; nEvent < ((m_nIDCourseInstance > 0) ? calendarEvents.size() : 0); nEvent++){
					try {
						checked = false;
						CalendarEvent cev = (CalendarEvent)calendarEvents.get(nEvent);
						String q = "SELECT * FROM TASK_CALENDAR_EVENTS WHERE CALENDAR_EVENTS_ID="
							+ cev.getID() + " AND ASSIGNMENTS_ID=" + m_nIDAssignment;
						ResultSet rs = DBConnection.query(q);
						if (rs.next()) checked = true;
						table.addRow(cev.getID(), new String[]
									{cev.getType(),
									 (cev.getName()==null)?"":cev.getName(),
									 (cev.getDescription()==null)?"":cev.getDescription(),
									 cev.getStartDate().toString(),
									 cev.getEndDate().toString(),
									 (cev.getPoints()==0)?"":cev.getPoints()+"",
									 (cev.getMandatory()==0)?MessagesBundle.getString("key_no", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale())
									 			:MessagesBundle.getString("key_yes", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale())
									}, checked);
						DBConnection.closeResultSet(rs);
                        			rs.close();
					} catch(Exception ex) {
						Exception e = new Exception ("CalendarEvents::render: exception at reading calendar events " + nEvent + "<br>" + ex);
						throw e;
					}
				}
				table.setOnSelect("document.forms[0].CalendarEvent.value=this.value; SetEvent.disabled = false;");
				addVisualObject(table);
				addVisualObject(new StaticText ("<br>"));
				ButtonBar bar = new ButtonBar();
				bar.setAlignment("center");
				Button bnSetEvent = new Button(Button.C_TYPE_BUTTON,
									 MessagesBundle.getString("key_set_event", ArcadeConstants.DEFAULT_BUNDLE, wb.getUserLocale()),
									 null);
				bnSetEvent.setName("SetEvent");
				addHandler(bnSetEvent, "OnSetEvent", c_EVENT_ON_CLICK);
				if (m_nIDAssignment < 1) bnSetEvent.Disable();
				bar.addButton(bnSetEvent);
				addVisualObject(bar);
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	private Dialog OnAssignmentSelect(WebBean wb) {
		m_nIDCalendarEvent = -1;
		return this;
	}
	
	private Dialog OnSetEvent(WebBean wb) {
		m_nAction = 1;
		return this;
	}
	private Dialog OnBack(WebBean wb){
		return getParent();
	}
}
